open Core_c
open Highgui_c
open Imgproc_c

let () =
  let capture = cvCreateCameraCapture 0 in
  let gray = cvCreateMat 480 640 CV_8UC1 in (* height width *)
  (* Create a window in which the captured images will be presented *)
  cvNamedWindow "mywindow" Window_AutoSize;
  (* Show the image captured from the camera in the window and repeat *)
  let rec loop () =
    (* Get one frame *)
    let frame = cvQueryFrame capture in
    cvCvtColor (Obj.magic frame) gray CV_BGR2GRAY;
    cvShowImage "mywindow" (Obj.magic gray);
    if ((cvWaitKey 1) land 255) <> 27
    then loop ()
  in
  loop ();
  cvReleaseCapture capture;
  cvDestroyWindow "mywindow";
;;
