external main : string array -> unit
  = "caml_my_cv_main"

type image

external image_dims : image -> int * int
  = "caml_IplImage_dims"

external cvReleaseImage : img:image -> unit
  = "caml_cvReleaseImage"

type cv_mat_type =
  | CV_8UC1
  | CV_8UC2
  | CV_8UC3
  | CV_8UC4
  | CV_8SC1
  | CV_8SC2
  | CV_8SC3
  | CV_8SC4
  | CV_16UC1
  | CV_16UC2
  | CV_16UC3
  | CV_16UC4
  | CV_16SC1
  | CV_16SC2
  | CV_16SC3
  | CV_16SC4
  | CV_32SC1
  | CV_32SC2
  | CV_32SC3
  | CV_32SC4
  | CV_32FC1
  | CV_32FC2
  | CV_32FC3
  | CV_32FC4
  | CV_64FC1
  | CV_64FC2
  | CV_64FC3
  | CV_64FC4

type cv_mat

external cvCreateMat: rows:int -> cols:int -> typ:cv_mat_type -> cv_mat
  = "caml_cvCreateMat"

external cv_mat_dims : cv_mat -> int * int
  = "caml_CvMat_dims"

external get_cv_mat_type : cv_mat -> cv_mat_type
  = "caml_CvMat_get_kind"

type cv_arr

external cvFlip :
  src:cv_arr ->
  dst:cv_arr ->
  flip_mode:int -> unit
  = "caml_cvFlip"
(* Mirror array data around horizontal (flip=0),
   vertical (flip=1) or both(flip=-1) axises:
   cvFlip(src) flips images vertically and sequences horizontally (inplace) *)

external cvMirror :
  src:cv_arr ->
  flip_mode:int -> unit
  = "caml_cvMirror"

external cvMat_get_step : cv_mat -> int
  = "caml_CvMat_get_step"

external cvMat_get_type : cv_mat -> int
  = "caml_CvMat_get_type"

type int_kind =
  | Uchar
  | Short
  | Int

external cvMat_get_int : cv_mat -> int_kind -> int -> int
  = "caml_CvMat_get_int"

type float_kind =
  | Float
  | Double

external cvMat_get_float : cv_mat -> float_kind -> int -> float
  = "caml_CvMat_get_float"

type color
val rgb : float * float * float -> color
val rgba : float * float * float * float -> color

external cvLine :
  img:cv_arr -> pt1:int * int -> pt2:int * int -> color:color ->
  thickness:int -> line_type:int -> shift:int -> unit
  = "caml_cvLine_bc"
    "caml_cvLine"

