/* Copyright (C) 2012, Florent Monnier, all rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

   * Redistribution's of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.

   * Redistribution's in binary form must reproduce the above copyright notice,
     this list of conditions and the following disclaimer in the documentation
     and/or other materials provided with the distribution.

   * The name of the copyright holders may not be used to endorse or promote
     products derived from this software without specific prior written
     permission.

 This software is provided by the copyright holders and contributors "as is" and
 any express or implied warranties, including, but not limited to, the implied
 warranties of merchantability and fitness for a particular purpose are
 disclaimed.  In no event shall the Intel Corporation or contributors be liable
 for any direct, indirect, incidental, special, exemplary, or consequential
 damages (including, but not limited to, procurement of substitute goods or
 services; loss of use, data, or profits; or business interruption) however
 caused and on any theory of liability, whether in contract, strict liability,
 or tort (including negligence or otherwise) arising in any way out of the
 use of this software, even if advised of the possibility of such damage.
*/

#include <opencv2/video/tracking.hpp>
#include <opencv2/video/background_segm.hpp>
#include "cv_caml_incs.h"

CAMLprim value
caml_cvCalcOpticalFlowFarneback(
        value prev, value next, value flow,
        value pyr_scale, value levels,
        value winsize, value iterations, value poly_n,
        value poly_sigma, value flags)
{
    cvCalcOpticalFlowFarneback(
            (CvArr *) prev,
            (CvArr *) next,
            (CvArr *) flow,
            Double_val(pyr_scale), Int_val(levels),
            Int_val(winsize), Int_val(iterations), Int_val(poly_n),
            Double_val(poly_sigma), Int_val(flags));

    return Val_unit;
}

CAMLprim value
caml_cvCalcOpticalFlowFarneback_bc(value *argv, int argn)
{
    return caml_cvCalcOpticalFlowFarneback(
            argv[0], argv[1], argv[2], argv[3], argv[4],
            argv[5], argv[6], argv[7], argv[8], argv[9]);
}

/* vim: set sw=4 sts=4 ts=4 et: */
