(** Capture *)

type capture
type image = Core_c.image

external cvCreateCameraCapture : index:int -> capture
  = "caml_cvCreateCameraCapture"

external cvReleaseCapture : capture -> unit
  = "caml_cvReleaseCapture"

external cvQueryFrame : capture -> image
  = "caml_cvQueryFrame"

external cvShowImage : name:string -> img:image -> unit
  = "caml_cvShowImage"

(** Window *)

type window_flags =
  | Window_Normal
  | Window_AutoSize
  | Window_FullScreen
  | Window_FreeRatio
  | Window_KeepRatio

external cvNamedWindow : name:string -> flags:window_flags -> unit
  = "caml_cvNamedWindow"

external cvResizeWindow :
  name:string -> width:int -> height:int -> unit
  = "caml_cvResizeWindow"

external cvMoveWindow :
  name:string -> x:int -> y:int -> unit
  = "caml_cvMoveWindow"

external cvDestroyWindow :
  name:string -> unit
  = "caml_cvDestroyWindow"

external cvWaitKey : delay:int -> int
  = "caml_cvWaitKey"

